---
id: 1103
title: Spoofing EDID, fixing our Beamer
date: 2018-09-18T19:08:01+00:00
author: xro
layout: post
guid: http://wp.realraum.at/?p=1103
permalink: /2018/09/spoofing-edid-fixing-our-beamer/
responsive_meta_box_designation:
  - 
responsive_meta_box_facebook:
  - 
responsive_meta_box_twitter:
  - 
responsive_meta_box_googleplus:
  - 
responsive_meta_box_text_linkedin:
  - 
snap_isAutoPosted:
  - 1537290481
snap_MYURL:
  - 
snapEdIT:
  - 1
snapTW:
  - 's:380:"a:1:{i:0;a:12:{s:2:"do";s:1:"1";s:9:"msgFormat";s:15:"%TITLE% - %URL%";s:8:"attchImg";s:1:"1";s:9:"isAutoImg";s:1:"A";s:8:"imgToUse";s:0:"";s:9:"isAutoURL";s:1:"A";s:8:"urlToUse";s:0:"";s:4:"doTW";i:0;s:8:"isPosted";s:1:"1";s:4:"pgID";s:19:"1042098195155877888";s:7:"postURL";s:55:"https://twitter.com/realraum/status/1042098195155877888";s:5:"pDate";s:19:"2018-09-18 17:09:05";}}";'
categories:
  - english
  - MakingCrafting
  - Projekte
  - realraum News
---
As a hackerspace we regularly host user-groups and irregularly host talks and workshops and all of them need to use our beamer. Quite a downer then, that our beamer’s HDMI and DVI Input stopped working with newer laptop graphic cards. Especially since VGA started having it’s own issues: Dark slides transmitted over our long VGA cable cause the beamer to decide input has disappeared and switch the input off.

A look at the kernel messages with `dmesg` made the source of the problem immediately apparent. The CRC of the [EDID](https://en.wikipedia.org/wiki/Extended_Display_Identification_Data "EDID") the beamer sends over the HDMI/DVI cable is wrong. (Interestingly enough, the beamer EDID sent over VGA is fine). As a result, newer laptops decide that no HDMI/DVI cable has actually been attached. Nothing you can do. Certainly not with any user tools like `xrandr` or any Xorg driver or kernel module options. Believe us, we tried it all. (Even if a software solution would have been possible, it would certainly not have been convenient to hack each new speaker’s laptop and OS of choice on the spot.)

This needed fixing!

<!--more-->

Rather than risking our beamer in a hunt for its EDID flash, which we might be able to re-flash, we decided to man-in-the-middle the cable and spoof the EDID sent by the beamer. A couple of [ready-made solutions can be had on Amazon](https://www.amazon.de/s/ref=nb_sb_noss?&field-keywords=hdmi+edid&rh=i%3Aaps%2Ck%3Ahdmi+edid) for anything from 30€ to 150€ but only [one supports our beamers native resolution of 1280×800 and costs a whooping 75€](https://www.amazon.de/dp/B01FUJKUJG/).

We’re hackers however, and so built our own solution for <10€ from materials already lying around.

First we cut open a HDMI extension cable extracted the DDC wires as well as HDMI 5V and GND. DDC just uses I2C so in theory we can use any µC, connect the DDC wires leading to the host device (laptop) it’s SDA/SCL pins, make it answer requests for EDID information and be done.

There is even a ready made [firmware project for an AVR ATtiny on GitHub](https://github.com/ericwazhung/avr-edid-spoofer) which allowed us to get started right away and save a lot of time. (Beware the code is a bit crappy, can only send a single EDID and has problems with high-byte EDIDs, aka almost every modern EDID)

[<img class="aligncenter size-large wp-image-1102" src="http://wp.realraum.at/wp-content/uploads/2018/09/edid_spoofing_cable.svg-982x1024.png" alt="edid_spoofing_cable-svg" width="750" height="782" />](http://wp.realraum.at/wp-content/uploads/2018/09/edid_spoofing_cable.svg.png)

We used an ArduinoNanoV3 as a programmer for the ATtiny and after fighting the firmware a bit (high-bytes), managed to find an EDID setting that would both compile and result int a laptop-hdmi-signal that was accepted by our beamer. It’s a weird 71.9 Hz signal, but it works reliably at native 1280×800. The lack of additional EDID modes might even be a boon, since it prevents laptops with different aspect ratios to autoselect a resolution that would yield crappy results.

[<img class="aligncenter size-large wp-image-1099" src="http://wp.realraum.at/wp-content/uploads/2018/09/wpid-DSC_8117-1024x576.jpg" alt="wpid-DSC_8117.JPG" width="750" height="422" />](http://wp.realraum.at/wp-content/uploads/2018/09/wpid-DSC_8117.jpg)

Finally we soldered the cable’s wires onto a 8pin socket and put whole thing in the casing of a dead H801. That way we still have the option of flashing better settings and firmware onto the ATtiny in the future. Add a few zip-ties for mechanical stability and voilà: Working HDMI port.

Note the zip-tie securing our hack to the fat HDMI extension.

[<img class="aligncenter size-large wp-image-1098" src="http://wp.realraum.at/wp-content/uploads/2018/09/wpid-dsc_81214657142107973808399-576x1024.jpg" alt="wpid-dsc_81214657142107973808399.jpg" width="576" height="1024" />](http://wp.realraum.at/wp-content/uploads/2018/09/wpid-dsc_81214657142107973808399.jpg)