---
id: 733
title: containers, e.g. with systemd
date: 2018-07-04T15:41:13+00:00
author: xro
layout: post
guid: http://wp.realraum.at/?p=733
permalink: /2018/07/bare-bone-containers-with-systemd-nspawn/
snap_isAutoPosted:
  - 1530711673
responsive_meta_box_designation:
  - 
responsive_meta_box_facebook:
  - 
responsive_meta_box_twitter:
  - 
responsive_meta_box_googleplus:
  - 
responsive_meta_box_text_linkedin:
  - 
snap_MYURL:
  - 
snapEdIT:
  - 1
snapTW:
  - 's:421:"a:1:{i:0;a:13:{s:2:"do";s:1:"1";s:10:"SNAPformat";s:15:"%TITLE% - %URL%";s:8:"attchImg";s:1:"1";s:9:"isAutoImg";s:1:"A";s:8:"imgToUse";s:0:"";s:4:"doTW";i:0;s:9:"msgFormat";s:15:"%TITLE% - %URL%";s:9:"isAutoURL";s:1:"A";s:8:"urlToUse";s:0:"";s:8:"isPosted";s:1:"1";s:4:"pgID";s:19:"1014504531030355968";s:7:"postURL";s:55:"https://twitter.com/realraum/status/1014504531030355968";s:5:"pDate";s:19:"2018-07-04 13:41:43";}}";'
categories:
  - english
tags:
  - randomthoughs
---
The more complex a program or application, the more likely it contains exploitable or otherwise dangerous faults. Containers are a way of limiting the damage by limiting an application access to the bare minimum. Ideally we would have a separate and instantly replaceable computer for every little daemon and service we run. Sadly, even with virtual machines, this would hardly be an efficient use of resources, so containers try to find a middle ground by allowing us to separate applications almost as if they were running on different machines, while actually sharing the same hardware and operating system kernel.

##### Several features come together to make this possible:

  * chroot
  * namespaces
  * cgroups

#### And it is a good idea to augment them with others:

  * seccomp-bpf syscall filter
  * packet filtering (ebtables)
  * virtual network devices
  * apparmor

Armed with these keywords, your week should now be filled with interesting and productive reading. :-)

If all you want are some opinionated basics however, read on:

<!--more-->

#### How to use a container?

The more containment and separation between applications, the more secure a system gets.
  
Unfortunately few applications come with ready-to-use definition of what access and other applications it requires to function at a minimum. There are ways of finding this out (makejail, documentation, strace, apparmor profiles), but it will always involve some work.
  
You have to find your own balance between the security one requires and the effort needed to attain it.

Furthermore, what even is an application? Is it a single program or daemon? Or a bunch of programs running in parallel and working in concert towards a single purpose?

#### How to NOT use a container?

Sometimes (web)developers see the Linux systems that run their (web)applications as a house of card that they better not touch or they don’t want to deal with security and quality policies of various Linux distributions. The reason being, that if it works for them, it should work just like that for the end-user. Conveniently containers now allow us to package an applications plus the whole linux ecosystem around it. Unfortunately this just makes everything worse. It makes it harder to actually secure and separate applications from each other while providing a false semblance of security.

### What is chroot and what can and can’t it do?

A chroot is a root file system (e.g. a whole Linux distribution) inside your host root file system in which a program runs.
  
The idea being that a chrooted application can not access any file outside it’s chroot.
  
Obviously then you have to provide (duplicate) all the tools and applications that will be needed inside the chroot filesystem.
  
Tools like debootstrap help installing a debian linux inside a directory or image.

Chroot does not restrict assess to the network, syscalls, hardware devices like usb etc.
  
E.g. The root user inside a chroot can easly read harddisk device or re-mount it inside the chroot and do whatever he/she pleases.

### Links to some great introduction to cgroups I came across

The RedHat-blog has some very good hands-on introduction articles on cgroups called “World domination with Cgroups” I suggest you read them:

  * <p class="hero1-title">
      <a href="https://www.redhat.com/en/about/blog/world-domination-cgroups-part-1-cgroup-basics">Part 1 – Cgroup basics</a>
    </p>

  * <p class="hero1-title">
      <a href="https://www.redhat.com/en/about/blog/world-domination-cgroups-part-2-turning-knobs">Part 2 – Turning Knobs</a>
    </p>

  * <p class="hero1-title">
      <a href="https://www.redhat.com/en/about/blog/world-domination-cgroups-part-3-thanks-memories">Part 3 – Thanks for the memories</a>
    </p>

  * <p class="hero1-title">
      <a href="https://www.redhat.com/en/about/blog/world-domination-cgroups-part-4-all-ios">Part 4 – All the I/Os</a>
    </p>

 

### Restrict services using systemd unit files

Sometimes you just want to contain a single executable. In that case you might not truly need a full machine, you can chroot a service and restrict it just using it’s .service file.

My favorite: <tt>SystemCallFilter</tt>! it filters what syscalls a process is allowed to use.

e.g. you could run a program or bunch of programs with _strace -c — <cmd>_ and put the list of syscalls at the end in the systemd unit file.

Other extremely useful directives you should read up on:

<pre>ProtectHome=read-only || true
ProtectKernelTunables=yes
ProtectSystem=strict || full || true
ProtectControlGroups=yes
PrivateDevices=true
#DevicePolicy=closed
#DeviceAllow=/dev/urandom r
#DeviceAllow=/dev/random r
NoNewPrivileges=true
ReadWritePaths=
ReadOnlyPaths=
InaccessiblePaths=
PrivateNetwork=
MountFlags=
AmbientCapabilities=
CapabilityBoundingSet=</pre>

 

chroot:

<pre>RootDirectory=</pre>

### What about containers as virtual machines replacement? Enter systemd-nspawn

systemd-nspawn is systemd’s tool to run containers like you would a virtual machine. Thus ‘nspawn containers are called “machines” and are managed with the tool <tt>machinectl</tt>. Actually machinectl interfaces not only with systemd-nspawn but also rkt, docker, libvirt and others, thus providing a convenient place to manage all your running virtualisations at once.

### Putting our application into an container.

Easy! Create a chroot under <tt>/var/lib/machines/examplecontainer/</tt> and a permission/network/container configuration-file <tt>/etc/systemd/nspawn/examplecontainer.nspawn</tt>. Then boot it using <tt>machinectl start examplecontainer</tt>. Done.

#### Example examplecontainer.nspawn

<pre>[Exec]
Boot=yes
PrivateUsers=no

[Network]
## put container (together with other containers)
## in a virtual private network-bridge called "examplevlan"
Zone=examplevlan
</pre>